#include <common.h>

//0=N 1=E 2=S 3=W

#define UNV_CELL 0x000F
#define N_WALL   0
#define E_WALL   1
#define S_WALL   2
#define W_WALL   3
#define N_BORDER 4
#define E_BORDER 5
#define S_BORDER 6
#define W_BORDER 7
#define N_BACKTR 12
#define E_BACKTR 13
#define S_BACKTR 14
#define W_BACKTR 15

#define setBit(sfr, bit)   ((sfr) |= (1 << (bit)))
#define clearBit(sfr, bit) ((sfr) &= ~(1 << (bit)))
#define getBit(sfr, bit)   ((sfr & ( 1 << bit )) >> bit)
#define isUnvisited(sfr)   ((sfr & 0x000F) == 15)

int random() {
  static long holdrand = 1;
  holdrand =  holdrand * 214013L + 2531011L;
  long temp = holdrand >> 16;
  temp = temp & 0x7fff;
  //return (((holdrand = holdrand * 214013L + 2531011L) >> 16) & 0x7fff);
  return temp;
}

void generate() {
  
  int x, y;
  unsigned short int maze[11][11];
  for (x = 10; x >= 0; x--) {
    for (y = 10; y >= 0; y--) {
      maze[x][y] = UNV_CELL;
	  if (y == 0)
        setBit(maze[x][y], N_BORDER);
      if (x == 10) 
        setBit(maze[x][y], E_BORDER);
      if (y == 10)
        setBit(maze[x][y], S_BORDER);
      if (x == 0)
        setBit(maze[x][y], W_BORDER);
    }
  }
  x = 0;
  y = 0;
  int a;
  char opencell[4] = {0, 0, 0, 0};
  while (1) {
    if (!getBit(maze[x][y], N_BORDER)) {
      if (isUnvisited(maze[x][y - 1])){
        opencell[0] = 1;
      }
    }
    if (!getBit(maze[x][y], E_BORDER)) {
      if (isUnvisited(maze[x + 1][y])){
        opencell[1] = 1;
      }
    }
    if (!getBit(maze[x][y], S_BORDER)) {
      if (isUnvisited(maze[x][y + 1])){
        opencell[2] = 1;
      }
    }
    if (!getBit(maze[x][y], W_BORDER)) {
      if (isUnvisited(maze[x - 1][y])){
        opencell[3] = 1;
      }
    }
    if (opencell[0] || opencell[1] || opencell[2] || opencell[3]) {
      while (1) {
        a = random() % 4; 
        if (opencell[a] == 1) {
	      opencell[0] = opencell[1] = opencell[2] = opencell[3] = 0;
          break;
        }
      }
    }
    else 
      if ((maze[x][y] & 0xF000) == 0) {
        break;
      if (getBit(maze[x][y], N_BACKTR)) {
        y--;
      }
      if (getBit(maze[x][y], E_BACKTR)) {
        x++;
      }
      if (getBit(maze[x][y], S_BACKTR)) {
        y++;
      }
      if (getBit(maze[x][y], W_BACKTR)) {
        y--;
      }
      continue;
    }
    if (a == 0) {
      maze[x][y] = clearBit(maze[x][y], N_WALL);
      y--;
      maze[x][y] = clearBit(maze[x][y], S_WALL);
      maze[x][y] = clearBit(maze[x][y], S_BACKTR);
    }
    if (a == 1) {
      maze[x][y] = clearBit(maze[x][y], E_WALL);
      x++;
      maze[x][y] = clearBit(maze[x][y], W_WALL);
      maze[x][y] = clearBit(maze[x][y], W_BACKTR);
    }
    if (a == 2) {
      maze[x][y] = clearBit(maze[x][y], S_WALL);
      y--;
      maze[x][y] = clearBit(maze[x][y], N_WALL);
      maze[x][y] = clearBit(maze[x][y], N_BACKTR);
    }
    if (a == 3) {
      maze[x][y] = clearBit(maze[x][y], W_WALL);
      x--;
      maze[x][y] = clearBit(maze[x][y], E_WALL);
      maze[x][y] = clearBit(maze[x][y], E_BACKTR);
    }
  }
  extern int map[26][26];
  extern float height[26][26];
  /*for (x = 0; x <= 25; x++) {
    for (y = 0; y <= 25; y++) {
      map[x][y] = 0;
      height[x][y] = 0;
      if (!(x % 2 || y % 2)) {
        map[x][y] = 1;
        height[x][y] = 1;
      }
      if (x == 1 || y == 1 || x == 24 || y == 24) {
        map[x][y] = 1;
        height[x][y] = 1;
      }
      if (x == 0 || y == 0 || x == 25 || y == 25) {
        map[x][y] = 0;
        height[x][y] = 0;
      }
    }
  }*/
  
}
